//+------------------------------------------------------------------+
//|                                                    FormSharp.mqh |
//|                                                            IgorM |
//|                              https://www.mql5.com/ru/users/igorm |
//+------------------------------------------------------------------+
#ifdef __MQL5__
#import "winformsmt5.dll"
#import
#else #ifdef __MQL4__
#import "winformsmt4.dll"
void CreateForms(double &t[],int b,int &o[],int a);
bool FormRun(int &button_,int &checkbox_);
void StateExchange(int &butt[],int lenb,int &checkb[],int lencheckb,double &d_inout[],int lend_inout,int &i_inout[],int lend_i_inout);
void StartEditOrderTable(int count);
void EditOrderTable(int count,string outsymbol,int outticket,string outtime,int outtype,double outvolume,double outprice,double outstoploss,
                    double outtakeprofit,double outswap,double outprofit,string outcomment);
void EndEditOrdertable();
void FormDeinit(int reas);
#import
#endif #endif

// define events
#define EventButtonOneClick   mbutton[0]>0
#define EventButtonManyClick  mbutton[0]<0
#define EventCheckBoxClick    mcheckbox[0]>0
#define RefreshOrdersTable(void)   WinSharp.RefreshOrderTable()

// array in & out
#define out_double            dInOut
#define out_int               iInOut
#define in_double             dInOut
#define in_int                iInOut
#define in_button             mbutton
#define in_checkbox           mcheckbox

// out value to form
#define out_ask               dInOut[0]
#define out_bid               dInOut[1]
#define out_balance           dInOut[2]
#define out_equity            dInOut[3]
#define out_margin            dInOut[4]
#define out_point             dInOut[5]
#define out_spread            iInOut[0]
#define out_digits            iInOut[1]

// in value to this EA
#define EditLot               WinSharp.dinout(9)
#define EditPrice             WinSharp.dinout(8)
#define Edit_d_TakeProfit     WinSharp.dinout(7)
#define Edit_d_StopLoss       WinSharp.dinout(6)
#define ContexMenuTicket      WinSharp.iinout(5)
#define ContexMenuTrailing    WinSharp.iinout(4)
#define Edit_i_TakeProfit     WinSharp.iinout(3)
#define Edit_i_StopLoss       WinSharp.iinout(2)
// define checkbox
#define CheckMarketOrder      WinSharp.checkbox(1)
#define CheckLimitOrder       WinSharp.checkbox(2)
#define CheckStopOrder        WinSharp.checkbox(3)
#define CheckShowOrders       WinSharp.checkbox(4)
#define Checkinpips           WinSharp.checkbox(5)


typedef void(*TFuncvoidPTR)(void);
void FuncButtonNull(){};
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class COrderTable
  {
private:
   int               reserve_size;
public:
                     COrderTable();
   void              ArrayResize(int    new_size);
   TICKET_TYPE       ticket[];
   int               type[];
   double            volume[],price[],stoploss[],takeprofit[],swap[],profit[];
   string            time[],comment[];
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
COrderTable::COrderTable()
  {
   reserve_size=fmax((int)AccountInfoInteger(ACCOUNT_LIMIT_ORDERS),10);
   ArrayResize(1);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void COrderTable::ArrayResize(int new_size)
  {
   ArrayResize(ticket,new_size,reserve_size);
   ArrayResize(type,new_size,reserve_size);
   ArrayResize(volume,new_size,reserve_size);
   ArrayResize(price,new_size,reserve_size);
   ArrayResize(stoploss,new_size,reserve_size);
   ArrayResize(takeprofit,new_size,reserve_size);
   ArrayResize(swap,new_size,reserve_size);
   ArrayResize(profit,new_size,reserve_size);
   ArrayResize(time,new_size,reserve_size);
   ArrayResize(comment,new_size,reserve_size);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CForm
  {
private:
   int               mbutton[];     //   ,  ,    - , 0- -   = 1,   =0
   int               mcheckbox[];   //  , 0- -    
   int               countfunc,szbutton,szcheckbox,szdInOut,sziInOut;// 
   TFuncvoidPTR      funcbutton[];  //   -   
   bool              IsTester;
   double            dInOut[10];
   TICKET_TYPE       iInOut[6];
   bool              EnableRefresh;
   void              GetStateMT();
   void              Work();
   MAGIC_TYPE        magic;
   int               refreshcount;
public:
   COrderTable       OrderTable;
                     CForm();
                    ~CForm(){ }
   void              OnInit();
   void              OnDeinit(int reason);
   void              OnTick(){ if(IsTester) Work(); }
   void              OnTimer(){ Work(); }
   void              AddEventButtonClick(TFuncvoidPTR func);
   bool              checkbox(int num)  { return(mcheckbox[num]>0); }
   double            dinout(int num)    { return(dInOut[num]); }
   TICKET_TYPE       iinout(int num)    { return(iInOut[num]); }
   void              RefreshOrderTable();
   void              RefreshHistoryOrderTable();
   void              SetMagicNumber(MAGIC_TYPE magic_){ magic=magic_; EnableRefresh=true; refreshcount=-1;}
  }
WinSharp;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CForm::GetStateMT()
  {
   out_ask     = SymbolInfoDouble(_Symbol,SYMBOL_ASK);
   out_bid     = SymbolInfoDouble(_Symbol,SYMBOL_BID);
   out_spread  = (int)SymbolInfoInteger(_Symbol,SYMBOL_SPREAD);
   out_balance = AccountInfoDouble(ACCOUNT_BALANCE);
   out_equity  = AccountInfoDouble(ACCOUNT_EQUITY);
   out_margin  = AccountInfoDouble(ACCOUNT_MARGIN);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CForm::CForm(void)
  {
   IsTester=MQLInfoInteger(MQL_TESTER);
   szdInOut = ArraySize(dInOut);
   sziInOut = ArraySize(iInOut);
   EnableRefresh=false;
  }
//+------------------------------------------------------------------+
//|    -    |
//+------------------------------------------------------------------+
void CForm::AddEventButtonClick(TFuncvoidPTR func)
  {
   if(countfunc<szbutton) funcbutton[countfunc++]=func;
   else Print(countfunc," Many functions added, no empty buttons in the form !");
  }
//+------------------------------------------------------------------+
void CForm::Work(void)
  {
   GetStateMT();

#ifdef __MQL5__
   FormsMT5::StateExchange(in_button,in_checkbox,in_double,in_int);
#else #ifdef __MQL4__
   StateExchange(in_button,szbutton,in_checkbox,szcheckbox,in_double,szdInOut,in_int,sziInOut);
#endif #endif
   if(EventButtonOneClick)
     {
      TFuncvoidPTR FuncPtr = funcbutton[mbutton[0]];

      FuncPtr();//        ,  mbutton[0]  
     }
   else                        //    = -1,         
     {
      if(EventButtonManyClick)
        {
         for(int i=1;i<countfunc;i++)
         {
           if(in_button[i]>0)
           {
             TFuncvoidPTR FuncPtr = funcbutton[i];

             FuncPtr();
           }
         }
        }
     }

  if(EnableRefresh)
     {
      if(CheckShowOrders)
        {
         if(refreshcount--<0)
           {
            refreshcount=REFRESHORDERTABLE;
            RefreshOrderTable();
            RefreshHistoryOrderTable();
           }
        }
     }
  }
//+------------------------------------------------------------------+
void CForm::OnInit(void)
  {
   int i;
   if(!IsTester) EventSetMillisecondTimer(REFRESH);
   GetStateMT();
   out_point = _Point;
   out_digits= _Digits;
#ifdef __MQL5__
   FormsMT5::CreateForms(out_double,out_int);
   while(!FormsMT5::FormRun(szbutton,szcheckbox)){Print("Main Form not init, sleep..."); Sleep(500);} //     -   
#else #ifdef __MQL4__
   CreateForms(out_double,szdInOut,out_int,sziInOut);
   while(!FormRun(szbutton,szcheckbox)) {Print("Main Form not init, sleep..."); Sleep(500);} //     -   
#endif #endif
   Print("Forms is RUN, Button = ",szbutton-1," , CheckBox  =",szcheckbox-1);
   ArrayResize(mbutton,szbutton);
   ArrayResize(mcheckbox,szcheckbox);
   ArrayResize(funcbutton,szbutton);
   countfunc=0;
   for(i=0;i<szbutton;i++) AddEventButtonClick(FuncButtonNull);
   countfunc=1;
  }
//+------------------------------------------------------------------+
#ifdef __MQL5__
void CForm::OnDeinit(int reason){FormsMT5::FormDeinit(reason);}
#else #ifdef __MQL4__
void CForm::OnDeinit(int reason){FormDeinit(reason);}
#endif #endif
//+------------------------------------------------------------------+
#define CFORMONINIT WinSharp.OnInit();
#define CFORMONDEINIT(Reason) WinSharp.OnDeinit(Reason);

//+------------------------------------------------------------------+
#define CFORMONTIMER WinSharp.OnTimer();
#define CFORMONTICK WinSharp.OnTick();


void OnTimer(void){ CFORMONTIMER; ::CFORMONTIMER_(); }
void OnTick(void){ CFORMONTICK; ::CFORMONTICK_(); }

#ifdef OnTimer
  #undef OnTimer
#endif // OnTimer

#ifdef OnTick
  #undef OnTick
#endif // OnTick

#define OnTimer CFORMONTIMER_
#define OnTick CFORMONTICK_
//+------------------------------------------------------------------+
#ifdef __MQL5__
#include "HistoryTable.mqh"
#endif // __MQL5__

void CForm::RefreshOrderTable()
  {
#ifdef __MQL5__
  const int Total = OrdersTotal();
  HISTORY History[];

  for (int i = 0; i < Total; i++)
    if (OrderSelect(i, SELECT_BY_POS))
      ArrayResize(History, ArraySize(History) + 1);



  /*const */HISTORYTABLE HistoryTable(History);

#define MACROS_HISTORYTABLE(A) A.Amount, A.Ticket, A.OpenTime, A.Type, A.Lots, A.Symbol, A.OpenPrice, A.StopLoss, A.TakeProfit,         \
                               A.ClosePrice, A.Commission, A.Swap, A.Profit, A.Comment, A.Pips, A.SlipPage, A.MagicNumber, A.LengthTime
if(!HistoryTable.Amount) FormsMT5::ClearTOrder();
else FormsMT5::EditTOrder(MACROS_HISTORYTABLE(HistoryTable)); //   .

#undef MACROS_HISTORYTABLE
#else #ifdef __MQL4__
   int i,j,count=0,k=OrdersTotal();
   for(i=0; i<k; i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderMagicNumber()==magic && OrderSymbol()==_Symbol)
           {
            count++;
            OrderTable.ArrayResize(count);
            j=count-1;
            OrderTable.ticket[j]    = OrderTicket();
            OrderTable.time[j]      = TimeToString(OrderOpenTime(),TIME_DATE|TIME_MINUTES|TIME_SECONDS);
            OrderTable.type[j]      = OrderType();
            OrderTable.volume[j]    = OrderLots();
            OrderTable.price[j]     = OrderOpenPrice();
            OrderTable.stoploss[j]  = OrderStopLoss();
            OrderTable.takeprofit[j]= OrderTakeProfit();
            OrderTable.swap[j]      = OrderSwap();
            OrderTable.profit[j]    = OrderProfit();
            OrderTable.comment[j]   = OrderComment();
           }
        }
     }

   StartEditOrderTable(count);
   StartEditOrderTable(count);
   for(i=0;i<count;i++)
      EditOrderTable(i,_Symbol,OrderTable.ticket[i],OrderTable.time[i],OrderTable.type[i],OrderTable.volume[i],OrderTable.price[i],
                     OrderTable.stoploss[i],OrderTable.takeprofit[i],OrderTable.swap[i],OrderTable.profit[i],OrderTable.comment[i]);
   EndEditOrdertable();
#endif #endif
  }


#ifdef __MQL5__
void CForm::RefreshHistoryOrderTable()
  {
   static int PrevTotal = 0;
   static long PrevCurrentTime = 0;

   MqlTick Tick;

   if (SymbolInfoTick(_Symbol, Tick) && (Tick.time_msc < PrevCurrentTime))
   {
     FormsMT5::THistoryClear();

     PrevTotal = 0;
   }

   PrevCurrentTime = Tick.time_msc;

   const int Total = OrdersHistoryTotal();
   const bool IsChange = (Total != PrevTotal);

#define _CS(A) ((!::IsStopped()) && (A))
   while (_CS(PrevTotal < Total))
    if (OrderSelect(PrevTotal++, SELECT_BY_POS, MODE_HISTORY))
    {
      const HISTORY History(PrevTotal == 1);

    #define MACROS_HISTORY(A) A.Number, A.Ticket, A.OpenTime, A.Type, A.Lots, A.Symbol, A.OpenPrice, A.StopLoss, A.TakeProfit, A.CloseTime,       \
                              A.ClosePrice, A.Commission, A.Swap, A.Profit, A.Comment, A.Pips, A.SlipPage, A.MagicNumber, A.LengthTime, A.Balance
      FormsMT5::AddInTableHistory(MACROS_HISTORY(History));
    #undef MACROS_HISTORY
    }
//    ,      ,      
//         FormsMT5::THistoryRefresh();
static bool FirstRunSendDataInTHistory = true;
if(FirstRunSendDataInTHistory)
{
   if(FormsMT5::THistoryRun())
   {
      FirstRunSendDataInTHistory = false;
      Print("  ");
   }
} else if (IsChange)
  FormsMT5::THistoryRefresh();

  }
 #else // __MQL5__
void CForm::RefreshHistoryOrderTable() {}
 #endif // __MQL5__

//+------------------------------------------------------------------+